export declare type Unsubscribe = () => void;
export declare type Subscribe = (storage: any) => Unsubscribe;
declare type TStorage = {
    delete(key: string): void;
    deleteAll(): void;
    get<T = unknown>(key: string): T | string | null;
    has(key: string): boolean;
    listener: Subscribe;
    clearListeners: () => void;
};
export declare type TypeStorage = TStorage & {
    json<T>(parse?: boolean): T;
    set<T = unknown>(key: string, object: T): void;
};
declare type CookieAge = number | string | Date;
export declare type SetCookiesParser = Array<{
    name: keyof SetCookies;
    parse: (opts: SetCookies) => string;
}>;
export declare type SetCookies = Partial<{
    domain: string;
    expires: CookieAge;
    maxAge: CookieAge;
    multiDomain?: boolean;
    partitioned: boolean;
    path: string;
    sameSite: "strict" | "lax" | "none" | "";
    useSecure: boolean;
}>;
export declare type CookieStorage = TStorage & {
    json<T>(): T;
    set<T = unknown>(key: string, object: T, parameters?: SetCookies): void;
};
export {};
//# sourceMappingURL=types.d.ts.map